/*
 *+--------------------------------------------------------------------------------------+
 *| Licensed Materials - Use restricted, please refer to the "Samples Gallery" terms and |
 *| conditions in the IBM International Program License Agreement.						 |	
 *|  Copyright IBM Corporation 2003, 2004. All Rights Reserved.						 |
 *+--------------------------------------------------------------------------------------+
 */
package itso.ad.common.logging;

import java.util.logging.Level;
import java.util.logging.Logger;

public class LogHelper {
	/**
	 * Comment for <code>LOG_CONFIG_FILE</code>
	 * @!generated "UML to Java (com.ibm.xtools.transform.uml2.java.internal.UML2JavaTransform)"
	 */
	private static String LOG_CONFIG_FILE = "log4j.xml";
	
	private final Logger logger;

	private LogHelper(Class component) {
		logger = Logger.getLogger(component.getName());
	}
	
	/**
	 * @param object
	 * @!generated "UML to Java (com.ibm.xtools.transform.uml2.java.internal.UML2JavaTransform)"
	 */
	public void debug(Object object) {
		logger.log(Level.FINEST,object.toString());
	}

	/**
	 * @param object
	 * @param exception
	 * @!generated "UML to Java (com.ibm.xtools.transform.uml2.java.internal.UML2JavaTransform)"
	 */
	public void debug(Object object, Throwable exception) {
		logger.log(Level.FINEST,object.toString(),exception);
	}

	/**
	 * @param object
	 * @!generated "UML to Java (com.ibm.xtools.transform.uml2.java.internal.UML2JavaTransform)"
	 */
	public void error(Object object) {
		logger.log(Level.SEVERE,object.toString());
	}

	/**
	 * @param object
	 * @param exception
	 * @!generated "UML to Java (com.ibm.xtools.transform.uml2.java.internal.UML2JavaTransform)"
	 */
	public void error(Object object, Throwable exception) {
		logger.log(Level.SEVERE,object.toString(),exception);
	}

	/**
	 * @param object
	 * @!generated "UML to Java (com.ibm.xtools.transform.uml2.java.internal.UML2JavaTransform)"
	 */
	public void info(Object object) {
		logger.log(Level.INFO,object.toString());
	}

	/**
	 * @param object
	 * @param exception
	 * @!generated "UML to Java (com.ibm.xtools.transform.uml2.java.internal.UML2JavaTransform)"
	 */
	public void info(Object object, Throwable exception) {
		logger.log(Level.INFO,object.toString(),exception);
	}

	/**
	 * @param object
	 * @!generated "UML to Java (com.ibm.xtools.transform.uml2.java.internal.UML2JavaTransform)"
	 */
	public void warn(Object object) {
		logger.log(Level.WARNING,object.toString());
	}

	/**
	 * @param object
	 * @param exception
	 * @generated "UML to Java (com.ibm.xtools.transform.uml2.java.internal.UML2JavaTransform)"
	 */
	public void warn(Object object, Throwable exception) {
		logger.log(Level.WARNING,object.toString(),exception);
	}

	/**
	 * @return
	 * @!generated "UML to Java (com.ibm.xtools.transform.uml2.java.internal.UML2JavaTransform)"
	 */
	public boolean isDebugEnabled() {
		return logger.isLoggable(Level.FINEST);
	}

	/**
	 * @return
	 * @!generated "UML to Java (com.ibm.xtools.transform.uml2.java.internal.UML2JavaTransform)"
	 */
	public boolean isInfoEnabled() {
		return logger.isLoggable(Level.INFO);
	}

	/**
	 * @param class_
	 * @return
	 * @!generated "UML to Java (com.ibm.xtools.transform.uml2.java.internal.UML2JavaTransform)"
	 */
	public static LogHelper getInstance(Class class_) {
		return new LogHelper(class_);
	}
}