/*
 *+--------------------------------------------------------------------------------------+
 *| Licensed Materials - Use restricted, please refer to the "Samples Gallery" terms and |
 *| conditions in the IBM International Program License Agreement.						 |	
 *|  Copyright IBM Corporation 2003, 2004. All Rights Reserved.						 |
 *+--------------------------------------------------------------------------------------+
 */


package itso.ad.presentation.servlet;

import itso.ad.business.framework.interfaces.to.ICustomerTO;

import java.io.IOException;
import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class DisplayAccountsServlet extends BaseServlet implements Servlet {
	/* (non-Java-doc)
	 * @see itso.ad.presentation.servlet.BaseServlet#BaseServlet()
	 */
	public DisplayAccountsServlet() {
		super();
	}

	/* (non-Java-doc)
	 * @see itso.ad.presentation.servlet.BaseServlet#performTask(HttpServletRequest req, HttpServletResponse resp)
	 */
	protected void performTask(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		try {
			ICustomerTO customer = getCustomer(req);
			java.util.List accounts = getPiggyBankService().getAccountsByCustomer(customer);
			req.setAttribute("accounts", accounts);
			forwardTo("/secure/DisplayAccountsResult.jsp", req, resp);
		} catch (Exception e) {
			handleException(e, req, resp);
		}
	}

}