/*
 *+--------------------------------------------------------------------------------------+
 *| Licensed Materials - Use restricted, please refer to the "Samples Gallery" terms and |
 *| conditions in the IBM International Program License Agreement.						 |	
 *|  Copyright IBM Corporation 2003, 2004. All Rights Reserved.						 |
 *+--------------------------------------------------------------------------------------+
 */
package itso.ad.presentation.gui;

import itso.ad.business.ejb.facade.PiggyBankController;
import itso.ad.business.ejb.facade.PiggyBankControllerHome;
import itso.ad.business.framework.exception.ServiceException;

import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.swing.JFrame;

public class PiggyBankTeller extends JFrame {
	
	// EJB session bean reference
	private static final String PIGGY_BANK_CONTROLLER_EJB_REF  = "ejb/PiggyBankController";
	private static final String PIGGY_BANK_CONTROLLER_JNDINAME = "ejb/itso/ad/business/ejb/facade/PiggyBankControllerHome";

	private javax.swing.JPanel jContentPane = null;

	private javax.swing.JLabel jLabel = null;
	private javax.swing.JLabel jLabel1 = null;
	private javax.swing.JLabel jLabel2 = null;
	private javax.swing.JTextField creditAccount = null;
	private javax.swing.JTextField checkReference = null;
	private javax.swing.JTextField amount = null;
	private javax.swing.JButton cashCheckButton = null;
	private javax.swing.JLabel message = null;
	
	public static void main(String[] args) {
		System.out.println("PiggyBank Teller Application Start");
		PiggyBankTeller app = new PiggyBankTeller();
		app.setVisible(true);
	}
	/**
	 * This is the default constructor
	 */
	public PiggyBankTeller() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(300, 200);
		this.setContentPane(getJContentPane());
		this.setTitle("PiggyBank Teller Application");
		this.addWindowListener(new java.awt.event.WindowAdapter() { 
			public void windowClosing(java.awt.event.WindowEvent e) {    
				System.out.println("PiggyBank Teller Application End");    
				System.exit(0);
			}
		});
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			java.awt.GridBagConstraints consGridBagConstraints11 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints9 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints12 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints14 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints13 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints15 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints18 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints16 = new java.awt.GridBagConstraints();
			consGridBagConstraints11.gridy = 1;
			consGridBagConstraints11.gridx = 0;
			consGridBagConstraints16.gridy = 3;
			consGridBagConstraints16.gridx = 1;
			consGridBagConstraints9.gridy = 0;
			consGridBagConstraints9.gridx = 0;
			consGridBagConstraints15.fill = java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagConstraints15.weightx = 1.0;
			consGridBagConstraints15.gridy = 2;
			consGridBagConstraints15.gridx = 1;
			consGridBagConstraints12.gridy = 2;
			consGridBagConstraints12.gridx = 0;
			consGridBagConstraints14.fill = java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagConstraints14.weightx = 1.0;
			consGridBagConstraints14.gridy = 1;
			consGridBagConstraints14.gridx = 1;
			consGridBagConstraints14.insets = new java.awt.Insets(5,10,5,10);
			consGridBagConstraints12.insets = new java.awt.Insets(5,10,5,10);
			consGridBagConstraints12.anchor = java.awt.GridBagConstraints.WEST;
			consGridBagConstraints18.gridy = 4;
			consGridBagConstraints18.gridx = 0;
			consGridBagConstraints18.gridwidth = 2;
			consGridBagConstraints18.fill = java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagConstraints18.insets = new java.awt.Insets(5,10,5,10);
			consGridBagConstraints11.insets = new java.awt.Insets(5,10,5,10);
			consGridBagConstraints11.anchor = java.awt.GridBagConstraints.WEST;
			consGridBagConstraints13.fill = java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagConstraints13.weightx = 1.0;
			consGridBagConstraints13.gridy = 0;
			consGridBagConstraints13.gridx = 1;
			consGridBagConstraints13.insets = new java.awt.Insets(5,10,5,10);
			consGridBagConstraints9.insets = new java.awt.Insets(5,10,5,10);
			consGridBagConstraints9.anchor = java.awt.GridBagConstraints.WEST;
			consGridBagConstraints15.insets = new java.awt.Insets(5,10,5,10);
			consGridBagConstraints16.insets = new java.awt.Insets(5,10,5,10);
			consGridBagConstraints16.fill = java.awt.GridBagConstraints.HORIZONTAL;
			jContentPane.setLayout(new java.awt.GridBagLayout());
			jContentPane.add(getJLabel(), consGridBagConstraints9);
			jContentPane.add(getJLabel1(), consGridBagConstraints11);
			jContentPane.add(getJLabel2(), consGridBagConstraints12);
			jContentPane.add(getCreditAccount(), consGridBagConstraints13);
			jContentPane.add(getCheckReference(), consGridBagConstraints14);
			jContentPane.add(getAmount(), consGridBagConstraints15);
			jContentPane.add(getCashCheckButton(), consGridBagConstraints16);
			jContentPane.add(getMessage(), consGridBagConstraints18);
		}
		return jContentPane;
	}
	/**
	 * This method initializes jLabel
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel() {
		if(jLabel == null) {
			jLabel = new javax.swing.JLabel();
			jLabel.setText("Credit account number");
		}
		return jLabel;
	}
	/**
	 * This method initializes jLabel1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1() {
		if(jLabel1 == null) {
			jLabel1 = new javax.swing.JLabel();
			jLabel1.setText("Check reference");
		}
		return jLabel1;
	}
	/**
	 * This method initializes jLabel2
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel2() {
		if(jLabel2 == null) {
			jLabel2 = new javax.swing.JLabel();
			jLabel2.setText("Amount");
		}
		return jLabel2;
	}
	/**
	 * This method initializes creditAccount
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getCreditAccount() {
		if(creditAccount == null) {
			creditAccount = new javax.swing.JTextField();
		}
		return creditAccount;
	}
	/**
	 * This method initializes checkReference
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getCheckReference() {
		if(checkReference == null) {
			checkReference = new javax.swing.JTextField();
		}
		return checkReference;
	}
	/**
	 * This method initializes amount
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getAmount() {
		if(amount == null) {
			amount = new javax.swing.JTextField();
		}
		return amount;
	}
	/**
	 * This method initializes cashCheckButton
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getCashCheckButton() {
		if(cashCheckButton == null) {
			cashCheckButton = new javax.swing.JButton();
			cashCheckButton.setText("Cash check");
			cashCheckButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					performTask();
				}
			});
		}
		return cashCheckButton;
	}
	/**
	 * This method initializes message
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getMessage() {
		if(message == null) {
			message = new javax.swing.JLabel();
			message.setText("Welcome to PiggyBank Teller Application");
		}
		return message;
	}
	
	// business logic
	void performTask() {
		System.out.println("Cash check start");
		String creditAccount  = getCreditAccount().getText();
		String checkReference = getCheckReference().getText();
		String amountText     = getAmount().getText();	
		Integer amount        = new Integer(0);

		try {
			getMessage().setText("Msg: Verifying the check with CityBank...");
			paint(getGraphics());
			amount = new Integer(Integer.parseInt(amountText));
			System.out.println("Retrieving PiggyBankController");
			InitialContext initialContext = new InitialContext();
			// use EJB reference or EJB JNDI name
			//Object nsObject = initialContext.lookup(new StringBuffer("java:comp/env/").append(PIGGY_BANK_CONTROLLER_EJB_REF).toString());
			Object nsObject = initialContext.lookup(PIGGY_BANK_CONTROLLER_JNDINAME);
			// Object nsObject = initialContext.lookup(PIGGY_BANK_CONTROLLER_JNDINAME);
			PiggyBankControllerHome piggyBankControllerHome = (PiggyBankControllerHome) PortableRemoteObject.narrow(nsObject, PiggyBankControllerHome.class);
			PiggyBankController     piggyBankController = piggyBankControllerHome.create();
			System.out.println("Cashing the check");
			piggyBankController.cashCheck(checkReference, amount, creditAccount);
			System.out.println("Cash check OK");
			getMessage().setText("Msg: Check is cashed");
		} catch (ServiceException e) {
			System.out.println("ServiceException: "+e.getMessage());
			String code = e.getErrorCode(); if (code == null) code = "error.unknown";
			Throwable t = e.getRootCause(); if (t == null) t = e;
			System.out.println("ServiceException: "+code+" "+t);
			if (code.equals("error.check.invalid"))
				getMessage().setText("Msg: Invalid check - says CityBank");
			else if (code.equals("error.credit.account"))
				getMessage().setText("Msg: Invalid account number");
			else
				getMessage().setText("Error: "+t);
		} catch (Exception e) {
			System.out.println("Exception:" + e.getMessage());
			e.printStackTrace();
			getMessage().setText(e.getClass().getName()+": "+e.getMessage());
		}
	}
}
